# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ClusterGroupMeta(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'annotations': 'dict(str, object)',
        'creation_time': 'str',
        'description': 'str',
        'generation': 'str',
        'labels': 'dict(str, object)',
        'parent_references': 'list[ClusterGroupMetaParentReferences]',
        'resource_version': 'str',
        'uid': 'str',
        'update_time': 'str'
    }

    attribute_map = {
        'annotations': 'annotations',
        'creation_time': 'creationTime',
        'description': 'description',
        'generation': 'generation',
        'labels': 'labels',
        'parent_references': 'parentReferences',
        'resource_version': 'resourceVersion',
        'uid': 'uid',
        'update_time': 'updateTime'
    }

    def __init__(self, annotations=None, creation_time=None, description=None, generation=None, labels=None, parent_references=None, resource_version=None, uid=None, update_time=None):  # noqa: E501
        """ClusterGroupMeta - a model defined in Swagger"""  # noqa: E501
        self._annotations = None
        self._creation_time = None
        self._description = None
        self._generation = None
        self._labels = None
        self._parent_references = None
        self._resource_version = None
        self._uid = None
        self._update_time = None
        self.discriminator = None
        if annotations is not None:
            self.annotations = annotations
        if creation_time is not None:
            self.creation_time = creation_time
        if description is not None:
            self.description = description
        if generation is not None:
            self.generation = generation
        if labels is not None:
            self.labels = labels
        if parent_references is not None:
            self.parent_references = parent_references
        if resource_version is not None:
            self.resource_version = resource_version
        if uid is not None:
            self.uid = uid
        if update_time is not None:
            self.update_time = update_time

    @property
    def annotations(self):
        """Gets the annotations of this ClusterGroupMeta.  # noqa: E501


        :return: The annotations of this ClusterGroupMeta.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._annotations

    @annotations.setter
    def annotations(self, annotations):
        """Sets the annotations of this ClusterGroupMeta.


        :param annotations: The annotations of this ClusterGroupMeta.  # noqa: E501
        :type: dict(str, object)
        """

        self._annotations = annotations

    @property
    def creation_time(self):
        """Gets the creation_time of this ClusterGroupMeta.  # noqa: E501


        :return: The creation_time of this ClusterGroupMeta.  # noqa: E501
        :rtype: str
        """
        return self._creation_time

    @creation_time.setter
    def creation_time(self, creation_time):
        """Sets the creation_time of this ClusterGroupMeta.


        :param creation_time: The creation_time of this ClusterGroupMeta.  # noqa: E501
        :type: str
        """

        self._creation_time = creation_time

    @property
    def description(self):
        """Gets the description of this ClusterGroupMeta.  # noqa: E501


        :return: The description of this ClusterGroupMeta.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ClusterGroupMeta.


        :param description: The description of this ClusterGroupMeta.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def generation(self):
        """Gets the generation of this ClusterGroupMeta.  # noqa: E501


        :return: The generation of this ClusterGroupMeta.  # noqa: E501
        :rtype: str
        """
        return self._generation

    @generation.setter
    def generation(self, generation):
        """Sets the generation of this ClusterGroupMeta.


        :param generation: The generation of this ClusterGroupMeta.  # noqa: E501
        :type: str
        """

        self._generation = generation

    @property
    def labels(self):
        """Gets the labels of this ClusterGroupMeta.  # noqa: E501


        :return: The labels of this ClusterGroupMeta.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._labels

    @labels.setter
    def labels(self, labels):
        """Sets the labels of this ClusterGroupMeta.


        :param labels: The labels of this ClusterGroupMeta.  # noqa: E501
        :type: dict(str, object)
        """

        self._labels = labels

    @property
    def parent_references(self):
        """Gets the parent_references of this ClusterGroupMeta.  # noqa: E501


        :return: The parent_references of this ClusterGroupMeta.  # noqa: E501
        :rtype: list[ClusterGroupMetaParentReferences]
        """
        return self._parent_references

    @parent_references.setter
    def parent_references(self, parent_references):
        """Sets the parent_references of this ClusterGroupMeta.


        :param parent_references: The parent_references of this ClusterGroupMeta.  # noqa: E501
        :type: list[ClusterGroupMetaParentReferences]
        """

        self._parent_references = parent_references

    @property
    def resource_version(self):
        """Gets the resource_version of this ClusterGroupMeta.  # noqa: E501


        :return: The resource_version of this ClusterGroupMeta.  # noqa: E501
        :rtype: str
        """
        return self._resource_version

    @resource_version.setter
    def resource_version(self, resource_version):
        """Sets the resource_version of this ClusterGroupMeta.


        :param resource_version: The resource_version of this ClusterGroupMeta.  # noqa: E501
        :type: str
        """

        self._resource_version = resource_version

    @property
    def uid(self):
        """Gets the uid of this ClusterGroupMeta.  # noqa: E501


        :return: The uid of this ClusterGroupMeta.  # noqa: E501
        :rtype: str
        """
        return self._uid

    @uid.setter
    def uid(self, uid):
        """Sets the uid of this ClusterGroupMeta.


        :param uid: The uid of this ClusterGroupMeta.  # noqa: E501
        :type: str
        """

        self._uid = uid

    @property
    def update_time(self):
        """Gets the update_time of this ClusterGroupMeta.  # noqa: E501


        :return: The update_time of this ClusterGroupMeta.  # noqa: E501
        :rtype: str
        """
        return self._update_time

    @update_time.setter
    def update_time(self, update_time):
        """Sets the update_time of this ClusterGroupMeta.


        :param update_time: The update_time of this ClusterGroupMeta.  # noqa: E501
        :type: str
        """

        self._update_time = update_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClusterGroupMeta, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClusterGroupMeta):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
